
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] imuInstall] >= 0 } {
    interp expose {} imuInstall
}

proc ::imuInstall { name } {
    foreach rqst { "Init" "GetInitParams" "Zero" "GetDeviceVersion" "SetAccelBiases" "ComputeAccelBiases" "ComputeAngSpeedsBiases" "DumpImuDataOnFile" "DumpImuDataStop" "GetSensorsData" "SetSensorsDataNumFile" "InitIntegratedData" "SetVariances" "FilterImuData" "GetFilterParams" "BackStepAttitudeEstimation" "StopBackStepAttitudeEstimation" "GetBackStepAttitudeEstimationParams" "SetHeadingPoster" "FlatTerrainMonitor" "StopMonitor" "GetMonitorParams" "SensorssensorsPosterRead" "AttitudeEstimationattitudeEstimationPosterRead" "SEPosposPosterRead" "MonitoringmonitorDataPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} imu$rqst $name
    }
}

interp hide {} imuInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] imuInit] >= 0 } {
    interp expose {} imuInit
}
if { [lsearch [interp hidden] imuInitFormatOutput] >= 0 } {
    interp expose {} imuInitFormatOutput
}

proc ::imuInit { name args } {
    set format {}
    lappend format [list string "Serial port" "/dev/ttyR3" ]
    lappend format [list int "Baud rate" 38400 ]
    lappend format [list int "Period (ticks)" 2 ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Open connexion to the DMU unit" \
	"ImuDevice\n| char port\[64\]\n| int baud\n| int period\n" \
	3 \
	$format \
	$args ]
}


proc ::imuInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuInit
interp hide {} imuInitFormatOutput





# GetInitParams ----------------------------------------------------------

if { [lsearch [interp hidden] imuGetInitParams] >= 0 } {
    interp expose {} imuGetInitParams
}
if { [lsearch [interp hidden] imuGetInitParamsFormatOutput] >= 0 } {
    interp expose {} imuGetInitParamsFormatOutput
}

proc ::imuGetInitParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetInitParams" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::imuGetInitParamsFormatOutput { list } {
    set format { {} status { } { device { } port { } baud { } period } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuGetInitParams
interp hide {} imuGetInitParamsFormatOutput





# Zero ----------------------------------------------------------

if { [lsearch [interp hidden] imuZero] >= 0 } {
    interp expose {} imuZero
}
if { [lsearch [interp hidden] imuZeroFormatOutput] >= 0 } {
    interp expose {} imuZeroFormatOutput
}

proc ::imuZero { name args } {
    set format {}
    lappend format [list double "Duration (s)" 6.000000 ]

    return [ ::cs::rqstSend "${name}" "Zero" \
	"Calibrate bias" \
	"double zero\n" \
	1 \
	$format \
	$args ]
}


proc ::imuZeroFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuZero
interp hide {} imuZeroFormatOutput





# GetDeviceVersion ----------------------------------------------------------

if { [lsearch [interp hidden] imuGetDeviceVersion] >= 0 } {
    interp expose {} imuGetDeviceVersion
}
if { [lsearch [interp hidden] imuGetDeviceVersionFormatOutput] >= 0 } {
    interp expose {} imuGetDeviceVersionFormatOutput
}

proc ::imuGetDeviceVersion { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetDeviceVersion" \
	"Get DMU Version" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::imuGetDeviceVersionFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuGetDeviceVersion
interp hide {} imuGetDeviceVersionFormatOutput





# SetAccelBiases ----------------------------------------------------------

if { [lsearch [interp hidden] imuSetAccelBiases] >= 0 } {
    interp expose {} imuSetAccelBiases
}
if { [lsearch [interp hidden] imuSetAccelBiasesFormatOutput] >= 0 } {
    interp expose {} imuSetAccelBiasesFormatOutput
}

proc ::imuSetAccelBiases { name args } {
    set format {}
    lappend format [list double "xAccel Bias" 0.000000 ]
    lappend format [list double "yAccel Bias" 0.000000 ]
    lappend format [list double "zAccel Bias" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "SetAccelBiases" \
	"Set values for the accelerations biases" \
	"IMU_SETACCELBIASES_PARAMS\n| double xAccelBias\n| double yAccelBias\n| double zAccelBias\n" \
	3 \
	$format \
	$args ]
}


proc ::imuSetAccelBiasesFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuSetAccelBiases
interp hide {} imuSetAccelBiasesFormatOutput





# ComputeAccelBiases ----------------------------------------------------------

if { [lsearch [interp hidden] imuComputeAccelBiases] >= 0 } {
    interp expose {} imuComputeAccelBiases
}
if { [lsearch [interp hidden] imuComputeAccelBiasesFormatOutput] >= 0 } {
    interp expose {} imuComputeAccelBiasesFormatOutput
}

proc ::imuComputeAccelBiases { name args } {
    set format {}
    lappend format [list double "Phi Measured (rad)" 0.000000 ]
    lappend format [list double "Psi Measured (rad)" 0.000000 ]
    lappend format [list double "Duration (s)" 10.000000 ]

    return [ ::cs::rqstSend "${name}" "ComputeAccelBiases" \
	"Compute the acceleration biases" \
	"IMU_COMPUTEACCELBIASES_PARAMS\n| double phiMeasured\n| double psiMeasured\n| double duration\n" \
	3 \
	$format \
	$args ]
}


proc ::imuComputeAccelBiasesFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuComputeAccelBiases
interp hide {} imuComputeAccelBiasesFormatOutput





# ComputeAngSpeedsBiases ----------------------------------------------------------

if { [lsearch [interp hidden] imuComputeAngSpeedsBiases] >= 0 } {
    interp expose {} imuComputeAngSpeedsBiases
}
if { [lsearch [interp hidden] imuComputeAngSpeedsBiasesFormatOutput] >= 0 } {
    interp expose {} imuComputeAngSpeedsBiasesFormatOutput
}

proc ::imuComputeAngSpeedsBiases { name args } {
    set format {}
    lappend format [list double "Duration (s)" 10.000000 ]

    return [ ::cs::rqstSend "${name}" "ComputeAngSpeedsBiases" \
	"Compute the angular speeds biases" \
	"IMU_COMPUTEANGSPEEDSBIASES_PARAMS\n| double duration\n" \
	1 \
	$format \
	$args ]
}


proc ::imuComputeAngSpeedsBiasesFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuComputeAngSpeedsBiases
interp hide {} imuComputeAngSpeedsBiasesFormatOutput





# DumpImuDataOnFile ----------------------------------------------------------

if { [lsearch [interp hidden] imuDumpImuDataOnFile] >= 0 } {
    interp expose {} imuDumpImuDataOnFile
}
if { [lsearch [interp hidden] imuDumpImuDataOnFileFormatOutput] >= 0 } {
    interp expose {} imuDumpImuDataOnFileFormatOutput
}

proc ::imuDumpImuDataOnFile { name args } {
    set format {}
    lappend format [list int "Dump Period (Number of Exec Task Cycles between 2 dumps)" 1 ]
    lappend format [list int "unused" 0 ]
    lappend format [list string "File Name" "/home/tpeynot/robots/atrv/modules/imu/IMUdump.data" ]

    return [ ::cs::rqstSend "${name}" "DumpImuDataOnFile" \
	"Dump data from IMU on a file" \
	"IMU_DUMPONFILE_PARAMS\n| int dumpPeriod\n| int unused\n| char fileName\[64\]\n" \
	3 \
	$format \
	$args ]
}


proc ::imuDumpImuDataOnFileFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuDumpImuDataOnFile
interp hide {} imuDumpImuDataOnFileFormatOutput





# DumpImuDataStop ----------------------------------------------------------

if { [lsearch [interp hidden] imuDumpImuDataStop] >= 0 } {
    interp expose {} imuDumpImuDataStop
}
if { [lsearch [interp hidden] imuDumpImuDataStopFormatOutput] >= 0 } {
    interp expose {} imuDumpImuDataStopFormatOutput
}

proc ::imuDumpImuDataStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "DumpImuDataStop" \
	"Stops DumpImuDataOnFile request" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::imuDumpImuDataStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuDumpImuDataStop
interp hide {} imuDumpImuDataStopFormatOutput





# GetSensorsData ----------------------------------------------------------

if { [lsearch [interp hidden] imuGetSensorsData] >= 0 } {
    interp expose {} imuGetSensorsData
}
if { [lsearch [interp hidden] imuGetSensorsDataFormatOutput] >= 0 } {
    interp expose {} imuGetSensorsDataFormatOutput
}

proc ::imuGetSensorsData { name args } {
    set format {}
    lappend format [list string "base File Name" "/home/tpeynot/robots/atrv/modules/imu/imuSensorsData." ]

    return [ ::cs::rqstSend "${name}" "GetSensorsData" \
	"Provides the Sensors Data in one file" \
	"IMU_GETSENSORSDATA_PARAMS\n| char baseFileName\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::imuGetSensorsDataFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuGetSensorsData
interp hide {} imuGetSensorsDataFormatOutput





# SetSensorsDataNumFile ----------------------------------------------------------

if { [lsearch [interp hidden] imuSetSensorsDataNumFile] >= 0 } {
    interp expose {} imuSetSensorsDataNumFile
}
if { [lsearch [interp hidden] imuSetSensorsDataNumFileFormatOutput] >= 0 } {
    interp expose {} imuSetSensorsDataNumFileFormatOutput
}

proc ::imuSetSensorsDataNumFile { name args } {
    set format {}
    lappend format [list int "Next ID number for GetSensorsData file" 0 ]
    lappend format [list int "unused" 0 ]

    return [ ::cs::rqstSend "${name}" "SetSensorsDataNumFile" \
	"Set the ID number for next file generated by the request GetSensorsData" \
	"IMU_SETSENSORSDATA_PARAMS\n| int getSensorsData_numFile\n| int unused\n" \
	2 \
	$format \
	$args ]
}


proc ::imuSetSensorsDataNumFileFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuSetSensorsDataNumFile
interp hide {} imuSetSensorsDataNumFileFormatOutput





# InitIntegratedData ----------------------------------------------------------

if { [lsearch [interp hidden] imuInitIntegratedData] >= 0 } {
    interp expose {} imuInitIntegratedData
}
if { [lsearch [interp hidden] imuInitIntegratedDataFormatOutput] >= 0 } {
    interp expose {} imuInitIntegratedDataFormatOutput
}

proc ::imuInitIntegratedData { name args } {
    set format {}
    lappend format [list double "xSpeed Initial value:" 0.000000 ]
    lappend format [list double "ySpeed Initial value:" 0.000000 ]
    lappend format [list double "zSpeed Initial value:" 0.000000 ]
    lappend format [list double "xPos Initial value:" 0.000000 ]
    lappend format [list double "yPos Initial value:" 0.000000 ]
    lappend format [list double "zPos Initial value:" 0.000000 ]
    lappend format [list double "roll Initial Value:" 0.000000 ]
    lappend format [list double "pitch Initial Value:" 0.000000 ]
    lappend format [list double "yaw Initial Value:" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "InitIntegratedData" \
	"Re-Initialization of the Integrated Data: Speeds and Positions" \
	"IMU_INTEGRATEDDATA_INITVALUES\n| double xSpeedInitValue\n| double ySpeedInitValue\n| double zSpeedInitValue\n| double xPosInitValue\n| double yPosInitValue\n| double zPosInitValue\n| double rollInitValue\n| double pitchInitValue\n| double yawInitValue\n" \
	9 \
	$format \
	$args ]
}


proc ::imuInitIntegratedDataFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuInitIntegratedData
interp hide {} imuInitIntegratedDataFormatOutput





# SetVariances ----------------------------------------------------------

if { [lsearch [interp hidden] imuSetVariances] >= 0 } {
    interp expose {} imuSetVariances
}
if { [lsearch [interp hidden] imuSetVariancesFormatOutput] >= 0 } {
    interp expose {} imuSetVariancesFormatOutput
}

proc ::imuSetVariances { name args } {
    set format {}
    lappend format [list double "xAccel Variance" 0.000000 ]
    lappend format [list double "yAccel Variance" 0.000000 ]
    lappend format [list double "zAccel Variance" 0.000000 ]
    lappend format [list double "yawRate Variance" 0.000000 ]
    lappend format [list double "pitchRate Variance" 0.000000 ]
    lappend format [list double "rollRate Variance" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "SetVariances" \
	"Set the Variances for the IMU data" \
	"IMU_VARIANCES\n| double xAccelVariance\n| double yAccelVariance\n| double zAccelVariance\n| double yawRateVariance\n| double pitchRateVariance\n| double rollRateVariance\n" \
	6 \
	$format \
	$args ]
}


proc ::imuSetVariancesFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuSetVariances
interp hide {} imuSetVariancesFormatOutput





# FilterImuData ----------------------------------------------------------

if { [lsearch [interp hidden] imuFilterImuData] >= 0 } {
    interp expose {} imuFilterImuData
}
if { [lsearch [interp hidden] imuFilterImuDataFormatOutput] >= 0 } {
    interp expose {} imuFilterImuDataFormatOutput
}

proc ::imuFilterImuData { name args } {
    set format {}
    lappend format [list { "IMU_FILTER_OFF" "IMU_FILTER_ON" } "Angular Speeds Filter ON/OFF" "IMU_FILTER_OFF" ]
    lappend format [list int "Number of samples used to filter angular speeds" 4 ]
    lappend format [list { "IMU_FILTER_OFF" "IMU_FILTER_ON" } "Accelerations Filter ON/OFF" "IMU_FILTER_OFF" ]
    lappend format [list int "Number of samples used to filter accelerations" 4 ]

    return [ ::cs::rqstSend "${name}" "FilterImuData" \
	"Starts a Gauss average Filter of the angular speeds & accelerations" \
	"IMU_FILTER_PARAMS\n| IMU_FILTER_MODE angularSpeedsFilterMode\n| int numSamplesUsedToFilter_angSpeeds\n| IMU_FILTER_MODE accelFilterMode\n| int numSamplesUsedToFilter_accel\n" \
	4 \
	$format \
	$args ]
}


proc ::imuFilterImuDataFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuFilterImuData
interp hide {} imuFilterImuDataFormatOutput





# GetFilterParams ----------------------------------------------------------

if { [lsearch [interp hidden] imuGetFilterParams] >= 0 } {
    interp expose {} imuGetFilterParams
}
if { [lsearch [interp hidden] imuGetFilterParamsFormatOutput] >= 0 } {
    interp expose {} imuGetFilterParamsFormatOutput
}

proc ::imuGetFilterParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetFilterParams" \
	"Flag = 0 -> Filter OFF;  1 -> Filter ON" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::imuGetFilterParamsFormatOutput { list } {
    set format { {} status { } { imuDataFilterParams { } angularSpeedsFilterMode { } numSamplesUsedToFilter_angSpeeds { } accelFilterMode { } numSamplesUsedToFilter_accel } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuGetFilterParams
interp hide {} imuGetFilterParamsFormatOutput





# BackStepAttitudeEstimation ----------------------------------------------------------

if { [lsearch [interp hidden] imuBackStepAttitudeEstimation] >= 0 } {
    interp expose {} imuBackStepAttitudeEstimation
}
if { [lsearch [interp hidden] imuBackStepAttitudeEstimationFormatOutput] >= 0 } {
    interp expose {} imuBackStepAttitudeEstimationFormatOutput
}

proc ::imuBackStepAttitudeEstimation { name args } {
    set format {}
    lappend format [list { "IMU_BACKSTEP_OFF" "IMU_BACKSTEP_ON" } "Estimation ON/OFF" "IMU_BACKSTEP_OFF" ]
    lappend format [list double "Km Gain" 1.000000 ]
    lappend format [list double "Kb Gain" 0.100000 ]

    return [ ::cs::rqstSend "${name}" "BackStepAttitudeEstimation" \
	"Attitude Estimation using Back Stepping Technique" \
	"IMU_BACKSTEPPING_PARAMS\n| IMU_BACKSTEP_MODE mode\n| double Km\n| double Kb\n" \
	3 \
	$format \
	$args ]
}


proc ::imuBackStepAttitudeEstimationFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuBackStepAttitudeEstimation
interp hide {} imuBackStepAttitudeEstimationFormatOutput





# StopBackStepAttitudeEstimation ----------------------------------------------------------

if { [lsearch [interp hidden] imuStopBackStepAttitudeEstimation] >= 0 } {
    interp expose {} imuStopBackStepAttitudeEstimation
}
if { [lsearch [interp hidden] imuStopBackStepAttitudeEstimationFormatOutput] >= 0 } {
    interp expose {} imuStopBackStepAttitudeEstimationFormatOutput
}

proc ::imuStopBackStepAttitudeEstimation { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopBackStepAttitudeEstimation" \
	"Stops the BackStep Attitude Estimation" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::imuStopBackStepAttitudeEstimationFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuStopBackStepAttitudeEstimation
interp hide {} imuStopBackStepAttitudeEstimationFormatOutput





# GetBackStepAttitudeEstimationParams ----------------------------------------------------------

if { [lsearch [interp hidden] imuGetBackStepAttitudeEstimationParams] >= 0 } {
    interp expose {} imuGetBackStepAttitudeEstimationParams
}
if { [lsearch [interp hidden] imuGetBackStepAttitudeEstimationParamsFormatOutput] >= 0 } {
    interp expose {} imuGetBackStepAttitudeEstimationParamsFormatOutput
}

proc ::imuGetBackStepAttitudeEstimationParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetBackStepAttitudeEstimationParams" \
	"Get Params for BackStep Attitude Estimation" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::imuGetBackStepAttitudeEstimationParamsFormatOutput { list } {
    set format { {} status { } { backStepParams { } mode { } Km { } Kb } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuGetBackStepAttitudeEstimationParams
interp hide {} imuGetBackStepAttitudeEstimationParamsFormatOutput





# SetHeadingPoster ----------------------------------------------------------

if { [lsearch [interp hidden] imuSetHeadingPoster] >= 0 } {
    interp expose {} imuSetHeadingPoster
}
if { [lsearch [interp hidden] imuSetHeadingPosterFormatOutput] >= 0 } {
    interp expose {} imuSetHeadingPosterFormatOutput
}

proc ::imuSetHeadingPoster { name args } {
    set format {}
    lappend format [list string "headingPosterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "SetHeadingPoster" \
	"Sets a source of heading information to be used to fill the SEPos poster" \
	"GEN_STRING64\n| char name\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::imuSetHeadingPosterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuSetHeadingPoster
interp hide {} imuSetHeadingPosterFormatOutput





# FlatTerrainMonitor ----------------------------------------------------------

if { [lsearch [interp hidden] imuFlatTerrainMonitor] >= 0 } {
    interp expose {} imuFlatTerrainMonitor
}
if { [lsearch [interp hidden] imuFlatTerrainMonitorFormatOutput] >= 0 } {
    interp expose {} imuFlatTerrainMonitorFormatOutput
}

proc ::imuFlatTerrainMonitor { name args } {
    set format {}
    lappend format [list int "Width of Energy Time window (nb of MonitorTask Cycles)" 1 ]
    lappend format [list { "IMU_MONITOR_LOG_ON" "IMU_MONITOR_LOG_OFF" } "Activate Logging on file ?" "IMU_MONITOR_LOG_OFF" ]
    lappend format [list string "Log File Name" "/home/tpeynot/Images/imuMonitorLog.data" ]
    lappend format [list float "Highest Level of Energy corresponding to FlatTerrain" 0.001000 ]
    lappend format [list float "Lowest Level of Energy for Rough Terrain" 0.010000 ]
    lappend format [list float "Sigma for Sigmoid (computed value, as if unused)" 0.004000 ]
    lappend format [list int "unused" 0 ]

    return [ ::cs::rqstSend "${name}" "FlatTerrainMonitor" \
	"Check whether the terrain is flat" \
	"IMU_MONITOR_PARAMS\n| int timewidth_nbCycles\n| IMU_MONITOR_LOG_FLAG logFlag\n| char fileName\[64\]\n| float MaxFlat\n| float MinRough\n| float sigmaSigmoid\n| int unused\n" \
	7 \
	$format \
	$args ]
}


proc ::imuFlatTerrainMonitorFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuFlatTerrainMonitor
interp hide {} imuFlatTerrainMonitorFormatOutput





# StopMonitor ----------------------------------------------------------

if { [lsearch [interp hidden] imuStopMonitor] >= 0 } {
    interp expose {} imuStopMonitor
}
if { [lsearch [interp hidden] imuStopMonitorFormatOutput] >= 0 } {
    interp expose {} imuStopMonitorFormatOutput
}

proc ::imuStopMonitor { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopMonitor" \
	"Stops the FlatTerrainMonitor request" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::imuStopMonitorFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuStopMonitor
interp hide {} imuStopMonitorFormatOutput





# GetMonitorParams ----------------------------------------------------------

if { [lsearch [interp hidden] imuGetMonitorParams] >= 0 } {
    interp expose {} imuGetMonitorParams
}
if { [lsearch [interp hidden] imuGetMonitorParamsFormatOutput] >= 0 } {
    interp expose {} imuGetMonitorParamsFormatOutput
}

proc ::imuGetMonitorParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetMonitorParams" \
	"Get content of Monitor Params struct" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::imuGetMonitorParamsFormatOutput { list } {
    set format { {} status { } { monitorParams { } timewidth_nbCycles { } logFlag { } fileName { } MaxFlat { } MinRough { } sigmaSigmoid { } unused } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuGetMonitorParams
interp hide {} imuGetMonitorParamsFormatOutput





# Sensorssensors ----------------------------------------------------------

if { [lsearch [interp hidden] imuSensorssensorsPosterRead] >= 0 } {
    interp expose {} imuSensorssensorsPosterRead
}
if { [lsearch [interp hidden] imuSensorssensorsPosterFormatOutput] >= 0 } {
    interp expose {} imuSensorssensorsPosterFormatOutput
}

proc ::imuSensorssensorsPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Sensorssensors" \
	"ImuPoster\n| double yaw\n| double pitch\n| double roll\n| double yawRate\n| double pitchRate\n| double rollRate\n| double yawRateBias\n| double pitchRateBias\n| double rollRateBias\n| double yawRateNoBias\n| double pitchRateNoBias\n| double rollRateNoBias\n| double yawVariance\n| double pitchVariance\n| double rollVariance\n| double xAccel\n| double yAccel\n| double zAccel\n| double xAccelBias\n| double yAccelBias\n| double zAccelBias\n| double xAccelNoBias\n| double yAccelNoBias\n| double zAccelNoBias\n| double xAccelFiltered\n| double yAccelFiltered\n| double zAccelFiltered\n| double yawRateFiltered\n| double pitchRateFiltered\n| double rollRateFiltered\n| double xSpeed\n| double ySpeed\n| double zSpeed\n| double xSpeedVariance\n| double ySpeedVariance\n| double zSpeedVariance\n| double xPos\n| double yPos\n| double zPos\n| double xPosVariance\n| double yPosVariance\n| double zPosVariance\n| double phiLama\n| double psiLama\n" \
	$args ]
}


proc ::imuSensorssensorsPosterFormatOutput { list } {
    set format { {} status { } { sensors { } yaw { } pitch { } roll { } yawRate { } pitchRate { } rollRate { } yawRateBias { } pitchRateBias { } rollRateBias { } yawRateNoBias { } pitchRateNoBias { } rollRateNoBias { } yawVariance { } pitchVariance { } rollVariance { } xAccel { } yAccel { } zAccel { } xAccelBias { } yAccelBias { } zAccelBias { } xAccelNoBias { } yAccelNoBias { } zAccelNoBias { } xAccelFiltered { } yAccelFiltered { } zAccelFiltered { } yawRateFiltered { } pitchRateFiltered { } rollRateFiltered { } xSpeed { } ySpeed { } zSpeed { } xSpeedVariance { } ySpeedVariance { } zSpeedVariance { } xPos { } yPos { } zPos { } xPosVariance { } yPosVariance { } zPosVariance { } phiLama { } psiLama } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuSensorssensorsPosterRead
interp hide {} imuSensorssensorsPosterFormatOutput





# AttitudeEstimationattitudeEstimation ----------------------------------------------------------

if { [lsearch [interp hidden] imuAttitudeEstimationattitudeEstimationPosterRead] >= 0 } {
    interp expose {} imuAttitudeEstimationattitudeEstimationPosterRead
}
if { [lsearch [interp hidden] imuAttitudeEstimationattitudeEstimationPosterFormatOutput] >= 0 } {
    interp expose {} imuAttitudeEstimationattitudeEstimationPosterFormatOutput
}

proc ::imuAttitudeEstimationattitudeEstimationPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "AttitudeEstimationattitudeEstimation" \
	"IMU_ATTITUDE_ESTIMATION\n| double gravityVector\[3\]\n| double Bestimated\[3\]\n| double attitudeAngles\[2\]\n" \
	$args ]
}


proc ::imuAttitudeEstimationattitudeEstimationPosterFormatOutput { list } {
    set format { {} status { } { attitudeEstimation { 3 } gravityVector { 3 } Bestimated { 2 } attitudeAngles } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuAttitudeEstimationattitudeEstimationPosterRead
interp hide {} imuAttitudeEstimationattitudeEstimationPosterFormatOutput





# SEPospos ----------------------------------------------------------

if { [lsearch [interp hidden] imuSEPosposPosterRead] >= 0 } {
    interp expose {} imuSEPosposPosterRead
}
if { [lsearch [interp hidden] imuSEPosposPosterFormatOutput] >= 0 } {
    interp expose {} imuSEPosposPosterFormatOutput
}

proc ::imuSEPosposPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SEPospos" \
	"POM_SENSOR_POS\n| int date\n| int pad\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n" \
	$args ]
}


proc ::imuSEPosposPosterFormatOutput { list } {
    set format { {} status { } { pos { } date { } pad { } { sensorToMain { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToBase { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToOrigin { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuSEPosposPosterRead
interp hide {} imuSEPosposPosterFormatOutput





# MonitoringmonitorData ----------------------------------------------------------

if { [lsearch [interp hidden] imuMonitoringmonitorDataPosterRead] >= 0 } {
    interp expose {} imuMonitoringmonitorDataPosterRead
}
if { [lsearch [interp hidden] imuMonitoringmonitorDataPosterFormatOutput] >= 0 } {
    interp expose {} imuMonitoringmonitorDataPosterFormatOutput
}

proc ::imuMonitoringmonitorDataPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MonitoringmonitorData" \
	"IMU_MONITOR_DATA\n| float pitchRateEnergy\n| float rollRateEnergy\n| float probaPitch\n| float probaRoll\n| float behavior\n| float time\n| IMU_MONITOR_STATUS status\n| int unused\n" \
	$args ]
}


proc ::imuMonitoringmonitorDataPosterFormatOutput { list } {
    set format { {} status { } { monitorData { } pitchRateEnergy { } rollRateEnergy { } probaPitch { } probaRoll { } behavior { } time { } status { } unused } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} imuMonitoringmonitorDataPosterRead
interp hide {} imuMonitoringmonitorDataPosterFormatOutput


